package org.nakedobjects.nof.reflect.remote.data;

import org.nakedobjects.nof.core.util.ToString;


public class DummyValueData implements ValueData {
    private static final long serialVersionUID = 1L;
    public String  value;
    public String type;

    public DummyValueData(String value) {
        this(value, String.class.getName());
    }
    
    public DummyValueData(final String  value, final String type) {
        super();
        this.value = value;
        this.type = type;
    }

    public String getEncodedValue() {
        return value;
    }

    public String getType() {
        return type;
    }

    public boolean equals(final Object obj) {
        if (obj == this) {
            return true;
        }

        if (obj instanceof DummyValueData) {
            DummyValueData ref = (DummyValueData) obj;
            return (value == null ? ref.value == null : value.equals(ref.value))
                    && (type == null ? ref.type == null : type.equals(ref.type));
        }
        return false;
    }

    public String toString() {
        ToString str = new ToString(this);
        str.append("type", type);
        str.append("value", value);
        return str.toString();
    }

}
// Copyright (c) Naked Objects Group Ltd.
