package test.org.nakedobjects.object.reflect;

import org.nakedobjects.noa.adapter.Naked;
import org.nakedobjects.noa.adapter.NakedReference;
import org.nakedobjects.noa.reflect.Consent;
import org.nakedobjects.noa.reflect.NakedObjectAction;
import org.nakedobjects.noa.security.Session;
import org.nakedobjects.noa.spec.NakedObjectSpecification;
import org.nakedobjects.nof.core.reflect.Allow;
import org.nakedobjects.nof.core.util.DebugString;
import org.nakedobjects.nof.reflect.peer.ActionParamPeer;
import org.nakedobjects.nof.reflect.peer.ActionPeer;
import org.nakedobjects.nof.reflect.peer.MemberIdentifier;
import org.nakedobjects.testing.TestSpecification;

import test.org.nakedobjects.utility.ExpectedSet;


public final class DummyActionPeer implements ActionPeer {
    
    private ExpectedSet expectedActions = new ExpectedSet();
    private String name;
    private NakedObjectSpecification[] paramterTypes;
    private Naked returnObject;
    private NakedObjectSpecification returnType;

    public void debugData(final DebugString debugString) {}

    public Naked execute(final NakedReference object, final Naked[] parameters) {
        expectedActions.addActual("execute " + getIdentifier() + " " + object);
        return returnObject;
    }

    public void expect(final String string) {
        expectedActions.addExpected(string);
    }

    public String getDescription() {
        return null;
    }

    public Object getExtension(final Class cls) {
        return null;
    }

    public Class[] getExtensions() {
        return null;
    }

    public String getHelp() {
        return null;
    }

    public MemberIdentifier getIdentifier() {
        return new DummyIdentifier(name);
    }

    public String getName() {
        return name;
    }
    
    public NakedObjectSpecification getOnType() {
        return new TestSpecification();
    }

    public int getParameterCount() {
        return 3;
    }

    public Object[] getParameterDefaults(NakedReference target) {
        return new Object[] { new String(), new Integer(123), null };
    }

    public String[] getParameterDescriptions() {
        return new String[] { "description one", "description two", "description three" };
    }
    
    public String[] getParameterNames() {
        return new String[] { "one", "two", "three" };
    }

    public Object[][] getParameterOptions(NakedReference target) {
        return new Object[][] { { "test", "the", "options" }, null, null };
    }

    public NakedObjectSpecification[] getParameterTypes() {
        return paramterTypes;
    }

    public boolean[] getOptionalParameters() {
        return new boolean[3];
    }

    public NakedObjectSpecification getReturnType() {
        return returnType;
    }

    public NakedObjectAction.Target getTarget() {
        return null;
    }

    public NakedObjectAction.Type getType() {
        return null;
    }

    public boolean isVisibleDeclaratively() {
        return true;
    }

    public boolean isVisibleForSession(
            Session session) {
        return true;
    }

    public boolean isVisible(final NakedReference target) {
        return true;
    }
    
    public Consent isUsableDeclaratively() {
        return Allow.DEFAULT;
    }

    public Consent isUsableForSession(
            Session session) {
        return Allow.DEFAULT;
    }

    public Consent isUsable(final NakedReference target) {
        return Allow.DEFAULT;
    }
    
    public boolean isOnInstance() {
        return true;
    }
    public Consent isParameterSetValidImperatively(final NakedReference object, final Naked[] parameters) {
        return null;
    }

    public void setupName(final String name) {
        this.name = name;
    }

    public void setUpParamterTypes(final NakedObjectSpecification[] paramterTypes) {
        this.paramterTypes = paramterTypes;
    }

    public void setupReturnObject(final Naked returnObject) {
        this.returnObject = returnObject;
    }

    public void setupReturnType(final NakedObjectSpecification returnType) {
        this.returnType = returnType;
    }

    public void verify() {
        expectedActions.verify();
    }

    public boolean[] canParametersWrap() {
        return new boolean[3];
    }

    public int[] getParameterMaxLengths() {
        return new int[3];
    }

    public int[] getParameterNoLines() {
        return new int[3];
    }

    public int[] getParameterTypicalLengths() {
        return new int[3];
    }
    
    public ActionParamPeer[] getParameters() {
        return new ActionParamPeer[] {
                new DummyActionParamPeer(),
                new DummyActionParamPeer(),
                new DummyActionParamPeer(),
        };
    }


}
// Copyright (c) Naked Objects Group Ltd.
