package test.org.nakedobjects.object.reflect;

import java.util.Vector;

import junit.framework.Assert;

import org.nakedobjects.noa.adapter.Naked;
import org.nakedobjects.noa.adapter.NakedCollection;
import org.nakedobjects.noa.adapter.NakedObject;
import org.nakedobjects.noa.adapter.NakedReference;
import org.nakedobjects.noa.reflect.Consent;
import org.nakedobjects.noa.security.Session;
import org.nakedobjects.noa.spec.NakedObjectSpecification;
import org.nakedobjects.nof.core.reflect.Allow;
import org.nakedobjects.nof.core.util.DebugString;
import org.nakedobjects.nof.core.util.NotImplementedException;
import org.nakedobjects.nof.reflect.peer.MemberIdentifier;
import org.nakedobjects.nof.reflect.peer.OneToManyPeer;

import test.org.nakedobjects.utility.ExpectedSet;


public class DummyOneToManyPeer implements OneToManyPeer {
    Vector actions = new Vector();
    private ExpectedSet expectedActions = new ExpectedSet();
    public NakedCollection getCollection;
    public boolean isEmpty;
    public String label;
    String name;

    public void addAssociation(final NakedObject inObject, final NakedObject associate) {
        actions.addElement("add " + inObject);
        actions.addElement("add " + associate);
    }

    public void assertAction(final int index, final String expected) {
        Assert.assertEquals(expected, actions.elementAt(index));
    }

    public void assertActions(final int noOfActions) {
        if (noOfActions != actions.size()) {
            Assert.fail("Expected " + noOfActions + ", but got " + actions.size());
        }
    }

    public void debugData(final DebugString debugString) {}

    public void expect(final String string) {
        expectedActions.addExpected(string);
    }

    public NakedCollection getAssociations(final NakedObject inObject) {
        actions.addElement("get " + inObject);
        return getCollection;
    }
    
    public String getBusinessKeyName() {
        return null;
    }
    
    public Naked getDefault(NakedReference target) {
        return null;
    }

    public String getDescription() {
        return null;
    }

    public Object getExtension(final Class cls) {
        return null;
    }
    
    public Class[] getExtensions() {
        return new Class[0];
    }

    public String getHelp() {
        return null;
    }

    public MemberIdentifier getIdentifier() {
        return new DummyIdentifier();
    }

    public String getName() {
        return null;
    }

    public Object[] getOptions(NakedReference target) {
        return null;
    }

    public NakedObjectSpecification getSpecification() {
        throw new NotImplementedException();
    }

    public void initAssociation(final NakedObject inObject, final NakedObject associate) {}

    public void initOneToManyAssociation(final NakedObject inObject, final NakedObject[] instances) {}

    public Consent isAddValid(final NakedObject container, final NakedObject element) {
        return null;
    }

    public boolean isPersisted() {
        return true;
    }

    public boolean isEmpty(final NakedObject inObject) {
        actions.addElement("empty " + inObject);
        return isEmpty;
    }

    public boolean isMandatory() {
        return false;
    }

    public Consent isRemoveValid(final NakedObject container, final NakedObject element) {
        return null;
    }

    public Consent isUsableDeclaratively() {
        return Allow.DEFAULT;
    }

    public Consent isUsableForSession(
            Session session) {
        return Allow.DEFAULT;
    }

    public Consent isUsable(final NakedReference target) {
        return null;
    }
    
    public boolean isVisibleDeclaratively() {
        return false;
    }

    public boolean isVisibleForSession(
            Session session) {
        return false;
    }

    public boolean isVisible(final NakedReference target) {
        return true;
    }

    public void removeAllAssociations(final NakedObject inObject) {
        actions.addElement("removeall " + inObject);
    }

    public void removeAssociation(final NakedObject inObject, final NakedObject associate) {
        actions.addElement("remove " + inObject);
        actions.addElement("remove " + associate);
    }

    public void verify() {
        expectedActions.verify();
    }



}
// Copyright (c) Naked Objects Group Ltd.
