package test.org.nakedobjects.object.reflect;

import java.util.Vector;

import junit.framework.Assert;

import org.nakedobjects.noa.adapter.NakedObject;
import org.nakedobjects.noa.adapter.NakedReference;
import org.nakedobjects.noa.reflect.Consent;
import org.nakedobjects.noa.security.Session;
import org.nakedobjects.noa.spec.NakedObjectSpecification;
import org.nakedobjects.nof.core.reflect.Allow;
import org.nakedobjects.nof.core.util.DebugString;
import org.nakedobjects.nof.reflect.peer.MemberIdentifier;
import org.nakedobjects.nof.reflect.peer.OneToOnePeer;

import test.org.nakedobjects.utility.ExpectedSet;


public class DummyOneToOnePeer implements OneToOnePeer {
    private ExpectedSet expectedActions = new ExpectedSet();
    Vector actions = new Vector();
    public NakedObject getObject;
    public boolean isEmpty;
    public boolean isVisible;

    public void clearAssociation(final NakedObject inObject, final NakedObject associate) {
        actions.addElement("clear " + inObject);
        actions.addElement("clear " + associate);
    }

    public void expect(final String string) {
        expectedActions.addExpected(string);
    }

    public NakedObject getAssociation(final NakedObject inObject) {
        actions.addElement("get " + inObject);
        return getObject;
    }

    public NakedObject getDefault(NakedObject target) {
        return null;
    }
    
    public Object[] getOptions(NakedReference target) {
        return null;
    }
    
    public Object getExtension(final Class cls) {
        return null;
    }

    public Class[] getExtensions() {
        return new Class[0];
    }

    public MemberIdentifier getIdentifier() {
        return null;
    }

    public NakedObjectSpecification getSpecification() {
        return null;
    }

    public void initAssociation(final NakedObject inObject, final NakedObject associate) {}

    public boolean isPersisted() {
        return true;
    }

    public boolean isEmpty(final NakedObject inObject) {
        actions.addElement("empty " + inObject);
        return isEmpty;
    }

    public boolean isMandatory() {
        return false;
    }

    public void setAssociation(final NakedObject inObject, final NakedObject associate) {
        actions.addElement("associate " + inObject);
        actions.addElement("associate " + associate);
    }

    public void verify() {
        expectedActions.verify();
    }

    public void assertAction(final int index, final String expected) {
        Assert.assertEquals(expected, actions.elementAt(index));
    }

    public Consent isAssociationValid(final NakedObject inObject, final NakedObject value) {
        return null;
    }

    public String getDescription() {
        return null;
    }

    public String getName() {
        return null;
    }

    public boolean isVisibleDeclaratively() {
        return true;
    }
    
    public boolean isVisibleForSession(
            Session session) {
        return true;
    }
    
    public boolean isVisible(final NakedReference target) {
        return isVisible;
    }
    
    public void setupVisible(final boolean isVisible) {
        this.isVisible = isVisible;
    }
    
    public Consent isUsableDeclaratively() {
        return Allow.DEFAULT;
    }

    public Consent isUsableForSession(
            Session session) {
        return Allow.DEFAULT;
    }

    public Consent isUsable(final NakedReference target) {
        return null;
    }

    public boolean isOptionEnabled() {
        return false;
    }
    

    public String getHelp() {
        return null;
    }

    public void debugData(final DebugString debugString) {}

    public String getBusinessKeyName() {
        return null;
    }

}
// Copyright (c) Naked Objects Group Ltd.
