package test.org.nakedobjects.object.reflect;

import junit.framework.Assert;

import org.nakedobjects.noa.adapter.NakedObject;
import org.nakedobjects.noa.adapter.NakedReference;
import org.nakedobjects.noa.reflect.Consent;
import org.nakedobjects.noa.security.Session;
import org.nakedobjects.noa.spec.NakedObjectSpecification;
import org.nakedobjects.nof.core.reflect.Allow;
import org.nakedobjects.nof.core.util.DebugString;
import org.nakedobjects.nof.reflect.peer.MemberIdentifier;
import org.nakedobjects.nof.reflect.peer.OneToOnePeer;
import org.nakedobjects.testing.DummyNakedObject;


public class TestPojoReferencePeer implements OneToOnePeer {
    public void clearAssociation(final NakedObject inObject, final NakedObject associate) {}

    public void debugData(final DebugString debugString) {}

    public NakedObject getAssociation(final NakedObject inObject) {
        Assert.assertTrue(inObject.getObject() instanceof TestPojo);

        Object reference = ((TestPojo) inObject).getReference();
        DummyNakedObject nakedObject = new DummyNakedObject();
        nakedObject.setupObject(reference);
        return nakedObject;
    }
    
    public String getBusinessKeyName() {
        return null;
    }
    
    public NakedObject getDefault(NakedObject target) {
        return null;
    }

    public String getDescription() {
        return null;
    }

    public Object getExtension(final Class cls) {
        return null;
    }

    public Class[] getExtensions() {
        return new Class[0];
    }

    public String getHelp() {
        return null;
    }

    public MemberIdentifier getIdentifier() {
        return null;
    }

    public String getName() {
        return null;
    }

    public Object[] getOptions(NakedReference target) {
        return null;
    }

    public NakedObjectSpecification getSpecification() {
        return null;
    }

    public void initAssociation(final NakedObject inObject, final NakedObject associate) {
        Assert.assertTrue(inObject.getObject() instanceof TestPojo);

        setAssociation(inObject, associate);
    }

    public Consent isAssociationValid(final NakedObject inObject, final NakedObject value) {
        return null;
    }

    public boolean isPersisted() {
        return true;
    }

    public boolean isEmpty(final NakedObject inObject) {
        Assert.assertTrue(inObject.getObject() instanceof TestPojo);
        return false;
    }

    public boolean isMandatory() {
        return false;
    }

    public boolean isOptionEnabled() {
        return false;
    }

    public Consent isUsableDeclaratively() {
        return Allow.DEFAULT;
    }

    public Consent isUsableForSession(
            Session session) {
        return Allow.DEFAULT;
    }

    public Consent isUsable(final NakedReference target) {
        return Allow.DEFAULT;
    }
    
    public boolean isVisibleDeclaratively() {
        return false;
    }

    public boolean isVisibleForSession(final Session session) {
        return false;
    }

    public boolean isVisible(final NakedReference target) {
        return true;
    }

    public void setAssociation(final NakedObject inObject, final NakedObject associate) {}

}
// Copyright (c) Naked Objects Group Ltd.
