package test.org.nakedobjects.object.reflect;

import junit.framework.Assert;

import org.nakedobjects.noa.adapter.NakedObject;
import org.nakedobjects.noa.adapter.NakedReference;
import org.nakedobjects.noa.adapter.NakedValue;
import org.nakedobjects.noa.reflect.Consent;
import org.nakedobjects.noa.reflect.Formatter;
import org.nakedobjects.noa.security.Session;
import org.nakedobjects.noa.spec.NakedObjectSpecification;
import org.nakedobjects.nof.core.adapter.value.IntAdapter;
import org.nakedobjects.nof.core.reflect.Allow;
import org.nakedobjects.nof.core.util.DebugString;
import org.nakedobjects.nof.reflect.peer.MemberIdentifier;
import org.nakedobjects.nof.reflect.peer.ValuePeer;


public class TestPojoValuePeer implements ValuePeer {
    
    public boolean canClear() {
        return false;
    }
    
    public boolean canWrap() {
        return false;
    }
    
    public void clearValue(NakedObject inObject) {}
    
    public void clearAssociation(final NakedObject inObject, final NakedObject associate) {}
    
    public void debugData(final DebugString debugString) {}

    public String getBusinessKeyName() {
        return null;
    }

    public NakedValue getDefault(NakedObject target) {
        return null;
    }
    
    public String getDescription() {
        return null;
    }
    
    public Object getExtension(final Class cls) {
        return null;
    }

    public Class[] getExtensions() {
        return new Class[0];
    }

    public Formatter getFormatter() {
        return null;
    }
    
    public String getHelp() {
        return null;
    }

    public MemberIdentifier getIdentifier() {
        return null;
    }
    
    public int getMaximumLength() {
        return 0;
    }

    public String getName() {
        return null;
    }
    
    public int getNoLines() {
        return 0;
    }

    public Object[] getOptions(NakedReference target) {
        return null;
    }

    public NakedObjectSpecification getSpecification() {
        return null;
    }
    
    public int getTypicalLineLength() {
        return 0;
    }
    
    public NakedValue getValue(final NakedObject inObject) {
        Assert.assertTrue(inObject.getObject() instanceof TestPojo);

        int value = ((TestPojo) inObject).getValue();
        return new IntAdapter(new Integer(value));
    }

    public void initValue(final NakedObject inObject, final NakedValue val) {
        Assert.assertTrue(inObject.getObject() instanceof TestPojo);

        setValue(inObject, val);
    }

    public boolean isPersisted() {
        return true;
    }

    public boolean isEmpty(final NakedObject inObject) {
        Assert.assertTrue(inObject.getObject() instanceof TestPojo);
        return false;
    }

    public boolean isMandatory() {
        return false;
    }

    public boolean isOptionEnabled() {
        return false;
    }

    public boolean isVisibleDeclaratively() {
        return false;
    }
    
    public boolean isVisibleForSession(final Session session) {
        return false;
    }
    
    public boolean isVisible(final NakedReference target) {
        return true;
    }
    
    public Consent isUsableDeclaratively() {
        return Allow.DEFAULT;
    }

    public Consent isUsableForSession(
            Session session) {
        return Allow.DEFAULT;
    }

    public Consent isUsable(final NakedReference target) {
        return Allow.DEFAULT;
    }
    
    public Consent isValueValid(final NakedObject inObject, final NakedValue value) {
        return null;
    }

    public void setValue(final NakedObject inObject, final NakedValue val) {
        Assert.assertTrue(inObject.getObject() instanceof TestPojo);

        int intValue = ((Integer) val.getObject()).intValue();
        ((TestPojo) inObject.getObject()).setValue(intValue);
    }

}
// Copyright (c) Naked Objects Group Ltd.
