package test.org.nakedobjects.object.reflect.defaults;

import junit.framework.TestSuite;

import org.apache.log4j.Level;
import org.apache.log4j.LogManager;
import org.nakedobjects.noa.adapter.NakedObject;
import org.nakedobjects.noa.reflect.ValueAssociation;
import org.nakedobjects.nof.core.adapter.value.IntAdapter;
import org.nakedobjects.nof.reflect.spec.ValueAssociationImpl;
import org.nakedobjects.testing.DummyNakedObject;
import org.nakedobjects.testing.TestSpecification;
import org.nakedobjects.testing.TestSystem;

import test.org.nakedobjects.object.NakedObjectTestCase;
import test.org.nakedobjects.object.reflect.TestPojo;
import test.org.nakedobjects.object.reflect.TestPojoValuePeer;


public class ValueAssociationTest extends NakedObjectTestCase {
    private static final String NAME = "SmallPerson";
    private static final String FIELD_ID = "SmallPerson";
    private static final String FIELD_LABEL = "Small Person";
    private NakedObject nakedObject;
    private ValueAssociation association;
    private TestSpecification type;
    private TestPojoValuePeer associationDelegate;
    private TestSystem system;

    public ValueAssociationTest(final String name) {
        super(name);
    }

    public static void main(final String[] args) {
        junit.textui.TestRunner.run(new TestSuite(ValueAssociationTest.class));
    }

    protected void setUp() throws Exception {
        LogManager.getLoggerRepository().setThreshold(Level.OFF);

        system = new TestSystem();
        system.init();

        nakedObject = new DummyNakedObject();
        ((DummyNakedObject) nakedObject).setupObject(new TestPojo());

        associationDelegate = new TestPojoValuePeer();
        type = new TestSpecification();
        association = new ValueAssociationImpl(NAME, type, associationDelegate);
    }

    protected void tearDown() throws Exception {
        system.shutdown();
    }

    public void testType() {
        assertEquals(type, association.getSpecification());
    }

    public void testName() {
        assertEquals(FIELD_ID, association.getId());
    }

    public void testLabel() {
        assertEquals(FIELD_LABEL, association.getName());
    }

    public void testInitValue() {
        association.initValue(nakedObject, new IntAdapter(new Integer(12)));
        assertEquals(12, ((TestPojo) nakedObject.getObject()).getValue());
    }

}
// Copyright (c) Naked Objects Group Ltd.
